# coding: utf-8

"""
    Identity Service API

    A list of identity, account and service management APIs.  # noqa: E501

    OpenAPI spec version: 1.6.5
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""

from __future__ import absolute_import

import re  # noqa: F401

# python 2 and python 3 compatibility library
import six

from idem_vra.client.vra_identity_lib.api_client import ApiClient


class OrgOAuthAppControllerApi(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    Ref: https://github.com/swagger-api/swagger-codegen
    """

    def __init__(self, api_client=None):
        if api_client is None:
            api_client = ApiClient()
        self.api_client = api_client

    def create_org_scoped_o_auth_client(self, body, org_id, **kwargs):  # noqa: E501
        """Create an OAuth2 client.  # noqa: E501

        Creates an organization scoped OAuth2 client. ### Access Policy | Role | Access | | ----- | ----- | | Platform operator | &#x2714;&#xFE0F; | | Organization Owner | &#x2714;&#xFE0F; | | Organization Member | &#x0274c; | | Service Account (Whitelisted Client) | &#x0274c; |   # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.create_org_scoped_o_auth_client(body, org_id, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param OrgIdOauthappsBody body: (required)
        :param str org_id: The organization ID. (required)
        :return: InlineResponse200
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_req'):
            return self.create_org_scoped_o_auth_client_with_http_info(body, org_id, **kwargs)  # noqa: E501
        else:
            (data) = self.create_org_scoped_o_auth_client_with_http_info(body, org_id, **kwargs)  # noqa: E501
            return data

    def create_org_scoped_o_auth_client_with_http_info(self, body, org_id, **kwargs):  # noqa: E501
        """Create an OAuth2 client.  # noqa: E501

        Creates an organization scoped OAuth2 client. ### Access Policy | Role | Access | | ----- | ----- | | Platform operator | &#x2714;&#xFE0F; | | Organization Owner | &#x2714;&#xFE0F; | | Organization Member | &#x0274c; | | Service Account (Whitelisted Client) | &#x0274c; |   # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.create_org_scoped_o_auth_client_with_http_info(body, org_id, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param OrgIdOauthappsBody body: (required)
        :param str org_id: The organization ID. (required)
        :return: InlineResponse200
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['body', 'org_id']  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in six.iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method create_org_scoped_o_auth_client" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'body' is set
        if ('body' not in params or
                params['body'] is None):
            raise ValueError("Missing the required parameter `body` when calling `create_org_scoped_o_auth_client`")  # noqa: E501
        # verify the required parameter 'org_id' is set
        if ('org_id' not in params or
                params['org_id'] is None):
            raise ValueError("Missing the required parameter `org_id` when calling `create_org_scoped_o_auth_client`")  # noqa: E501

        collection_formats = {}

        path_params = {}
        if 'org_id' in params:
            path_params['orgId'] = params['org_id']  # noqa: E501

        query_params = []

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        if 'body' in params:
            body_params = params['body']
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.select_header_accept(
            ['*/*'])  # noqa: E501

        # HTTP header `Content-Type`
        header_params['Content-Type'] = self.api_client.select_header_content_type(  # noqa: E501
            ['application/json'])  # noqa: E501

        # Authentication setting
        auth_settings = ['Authorization']  # noqa: E501

        return self.api_client.call_api(
            '/csp/gateway/am/api/orgs/{orgId}/oauth-apps', 'POST',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type='InlineResponse200',  # noqa: E501
            auth_settings=auth_settings,
            async_req=params.get('async_req'),
            _return_http_data_only=params.get('_return_http_data_only'),
            _preload_content=params.get('_preload_content', True),
            _request_timeout=params.get('_request_timeout'),
            collection_formats=collection_formats)

    def delete_org_scoped_o_auth_client(self, org_id, **kwargs):  # noqa: E501
        """Deletes an OAuth2 client.  # noqa: E501

        Deletes an organization scoped OAuth2 client. ### Access Policy | Role | Access | | ----- | ----- | | Platform operator | &#x2714;&#xFE0F; | | Organization Owner | &#x2714;&#xFE0F; | | Organization Member | &#x0274c; | | Service Account (Whitelisted Client) | &#x0274c; |   # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.delete_org_scoped_o_auth_client(org_id, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str org_id: (required)
        :param OrgIdOauthappsBody1 body:
        :return: InlineResponse2001
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_req'):
            return self.delete_org_scoped_o_auth_client_with_http_info(org_id, **kwargs)  # noqa: E501
        else:
            (data) = self.delete_org_scoped_o_auth_client_with_http_info(org_id, **kwargs)  # noqa: E501
            return data

    def delete_org_scoped_o_auth_client_with_http_info(self, org_id, **kwargs):  # noqa: E501
        """Deletes an OAuth2 client.  # noqa: E501

        Deletes an organization scoped OAuth2 client. ### Access Policy | Role | Access | | ----- | ----- | | Platform operator | &#x2714;&#xFE0F; | | Organization Owner | &#x2714;&#xFE0F; | | Organization Member | &#x0274c; | | Service Account (Whitelisted Client) | &#x0274c; |   # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.delete_org_scoped_o_auth_client_with_http_info(org_id, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str org_id: (required)
        :param OrgIdOauthappsBody1 body:
        :return: InlineResponse2001
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['org_id', 'body']  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in six.iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method delete_org_scoped_o_auth_client" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'org_id' is set
        if ('org_id' not in params or
                params['org_id'] is None):
            raise ValueError("Missing the required parameter `org_id` when calling `delete_org_scoped_o_auth_client`")  # noqa: E501

        collection_formats = {}

        path_params = {}
        if 'org_id' in params:
            path_params['orgId'] = params['org_id']  # noqa: E501

        query_params = []

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        if 'body' in params:
            body_params = params['body']
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.select_header_accept(
            ['*/*'])  # noqa: E501

        # HTTP header `Content-Type`
        header_params['Content-Type'] = self.api_client.select_header_content_type(  # noqa: E501
            ['application/json'])  # noqa: E501

        # Authentication setting
        auth_settings = ['Authorization']  # noqa: E501

        return self.api_client.call_api(
            '/csp/gateway/am/api/orgs/{orgId}/oauth-apps', 'DELETE',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type='InlineResponse2001',  # noqa: E501
            auth_settings=auth_settings,
            async_req=params.get('async_req'),
            _return_http_data_only=params.get('_return_http_data_only'),
            _preload_content=params.get('_preload_content', True),
            _request_timeout=params.get('_request_timeout'),
            collection_formats=collection_formats)

    def get_org_scoped_o_auth_client(self, org_id, oauth_app_id, **kwargs):  # noqa: E501
        """Get Organization Managed OAuth App.  # noqa: E501

        Get Organization Managed OAuth App that was created and is owned by the organization. ### Access Policy | Role | Access | | ----- | ----- | | Platform operator | &#x2714;&#xFE0F; | | Organization Owner | &#x2714;&#xFE0F; | | Organization Member | &#x0274c; | | Service Account (Whitelisted Client) | &#x0274c; |   # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.get_org_scoped_o_auth_client(org_id, oauth_app_id, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str org_id: (required)
        :param str oauth_app_id: (required)
        :return: InlineResponse20026
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_req'):
            return self.get_org_scoped_o_auth_client_with_http_info(org_id, oauth_app_id, **kwargs)  # noqa: E501
        else:
            (data) = self.get_org_scoped_o_auth_client_with_http_info(org_id, oauth_app_id, **kwargs)  # noqa: E501
            return data

    def get_org_scoped_o_auth_client_with_http_info(self, org_id, oauth_app_id, **kwargs):  # noqa: E501
        """Get Organization Managed OAuth App.  # noqa: E501

        Get Organization Managed OAuth App that was created and is owned by the organization. ### Access Policy | Role | Access | | ----- | ----- | | Platform operator | &#x2714;&#xFE0F; | | Organization Owner | &#x2714;&#xFE0F; | | Organization Member | &#x0274c; | | Service Account (Whitelisted Client) | &#x0274c; |   # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.get_org_scoped_o_auth_client_with_http_info(org_id, oauth_app_id, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str org_id: (required)
        :param str oauth_app_id: (required)
        :return: InlineResponse20026
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['org_id', 'oauth_app_id']  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in six.iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method get_org_scoped_o_auth_client" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'org_id' is set
        if ('org_id' not in params or
                params['org_id'] is None):
            raise ValueError("Missing the required parameter `org_id` when calling `get_org_scoped_o_auth_client`")  # noqa: E501
        # verify the required parameter 'oauth_app_id' is set
        if ('oauth_app_id' not in params or
                params['oauth_app_id'] is None):
            raise ValueError("Missing the required parameter `oauth_app_id` when calling `get_org_scoped_o_auth_client`")  # noqa: E501

        collection_formats = {}

        path_params = {}
        if 'org_id' in params:
            path_params['orgId'] = params['org_id']  # noqa: E501
        if 'oauth_app_id' in params:
            path_params['oauthAppId'] = params['oauth_app_id']  # noqa: E501

        query_params = []

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.select_header_accept(
            ['*/*'])  # noqa: E501

        # Authentication setting
        auth_settings = ['Authorization']  # noqa: E501

        return self.api_client.call_api(
            '/csp/gateway/am/api/orgs/{orgId}/oauth-apps/{oauthAppId}', 'GET',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type='InlineResponse20026',  # noqa: E501
            auth_settings=auth_settings,
            async_req=params.get('async_req'),
            _return_http_data_only=params.get('_return_http_data_only'),
            _preload_content=params.get('_preload_content', True),
            _request_timeout=params.get('_request_timeout'),
            collection_formats=collection_formats)
